package com.fins.html.utils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TreeFactory {

   private Map treeParent = new HashMap();
   private String curPid = null;
   private String PIDSTR = "pid";
   private String IDSTR = "id";


   public static void main(String[] a) {
      ArrayList datas = new ArrayList();
      HashMap map = new HashMap();
      map.put("id", "001");
      datas.add(map);
      map = new HashMap();
      map.put("id", "001002");
      datas.add(map);
      map = new HashMap();
      map.put("id", "001003");
      datas.add(map);
      map = new HashMap();
      map.put("id", "001003001");
      datas.add(map);
      map = new HashMap();
      map.put("id", "001003002");
      datas.add(map);
      map = new HashMap();
      map.put("id", "002");
      datas.add(map);
      map = new HashMap();
      map.put("id", "00201");
      datas.add(map);
      map = new HashMap();
      map.put("id", "00202");
      datas.add(map);
      map = new HashMap();
      map.put("id", "00203");
      datas.add(map);
      map = new HashMap();
      map.put("id", "00203001");
      datas.add(map);
      map = new HashMap();
      map.put("id", "00203002");
      datas.add(map);
      TreeFactory ta = new TreeFactory();
      List ll = ta.createTreeData(datas);
      System.out.println(ll);
   }

   public List createTreeData(List datas) {
      int len = datas.size();

      for(int i = 0; i < len; ++i) {
         Map data = (Map)datas.get(i);
         if(i == 0 && !this.checkID(data)) {
            throw new RuntimeException("生成树结构数据错误：缺少【ID】字段！");
         }

         this.createTreeNode(data);
      }

      return datas;
   }

   private boolean checkID(Map data) {
      if(data.keySet().contains("id")) {
         this.PIDSTR = "pid";
         this.IDSTR = "id";
         return true;
      } else if(data.keySet().contains("ID")) {
         this.PIDSTR = "PID";
         this.IDSTR = "ID";
         return true;
      } else {
         return false;
      }
   }

   public void createTreeNode(Map data) {
      Object oid = data.get(this.IDSTR);
      if(oid != null) {
         String sid = oid.toString();
         this.setDataPid(this.curPid, sid, data);
      }

   }

   public void setDataPid(String pid, String sid, Map data) {
      if(pid != null && !pid.equals("0")) {
         if(sid.startsWith(pid)) {
            this.setPid(pid, sid, data);
         } else {
            String temppid = (String)this.treeParent.get(pid);
            if(sid.startsWith(temppid)) {
               this.setPid(temppid, sid, data);
            } else {
               this.setDataPid(temppid, sid, data);
            }
         }
      } else {
         this.setPid("0", sid, data);
      }

   }

   public void setPid(String pid, String sid, Map data) {
      this.curPid = sid;
      data.put(this.PIDSTR, pid);
      this.treeParent.put(sid, pid);
   }
}
